﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace V409_test
{
    public class SimpleScreen
    {
        private int rowNumber = 4;
        private int columnNumber = 4;
        private Boolean lockFlag = true;
        private DataGridView dataGridView;

        private int selectSR = 1;
        private int selectSC = 1;
        private int selectER = 1;
        private int selectEC = 1;

        public int SelectSR
        {
            set
            {
                if (value > 0)
                {
                    selectSR = value;
                }
            }
            get { return selectSR; }
        }

        public int SelectSC
        {
            set
            {
                if (value > 0)
                {
                    selectSC = value;
                }
            }
            get { return selectSC; }
        }

        public int SelectER
        {
            set
            {
                if (value > 0)
                {
                    selectER = value;
                }
            }
            get { return selectER; }
        }

        public int SelectEC
        {
            set
            {
                if (value > 0)
                {
                    selectEC = value;
                }
            }
            get { return selectEC; }
        }


        public SimpleScreen(DataGridView dataGrid)
        {
            dataGridView = dataGrid;
        }


        public int RowNumber
        {
            set
            {
                if (value > 0)
                {
                    rowNumber = value;
                }
            }
            get
            {
                return rowNumber;
            }
        }

        public int ColumnNumber
        {
            set
            {
                if (value > 0)
                {
                    columnNumber = value;
                }
            }
            get
            {
                return columnNumber;
            }
        }


        public Boolean LockFlag
        {
            set
            {
                lockFlag = value;
            }
            get
            {
                return lockFlag;
            }
        }

        /*********************************************************/
        /// <summary>
        /// 重绘时调用的方法
        /// </summary>
        /// <param name="pH">panel1高</param>
        /// <param name="pW">panel1宽</param>
        public void RefreshScreen(int pH, int pW)
        {
            dataGridView.AllowUserToResizeColumns = true;
            dataGridView.AllowUserToResizeRows = true;

            if (lockFlag)
            {
                dataGridView.RowCount = rowNumber;
                dataGridView.ColumnCount = columnNumber;

                for (int r = 0; r < rowNumber; r++)
                {
                    dataGridView.Rows[r].Height = (pH - 5) / rowNumber;
                }

                for (int c = 0; c < columnNumber; c++)
                {
                    dataGridView.Columns[c].Width = (pW - 5) / columnNumber;
                }

                dataGridView.AllowUserToResizeColumns = false;
                dataGridView.AllowUserToResizeRows = false;
            }
        }

        public void DefaultSelectedArea()
        {
            selectSC = 1;
            selectEC = 1;
            selectSR = 1;
            selectER = 1;
        }

        public void SetScreenByConfig(int pH, int pW)
        {
            string valtmp;
            dataGridView.AllowUserToResizeColumns = true;
            dataGridView.AllowUserToResizeRows = true;


            if (lockFlag)
            {
                dataGridView.RowCount = rowNumber;
                dataGridView.ColumnCount = columnNumber;

                foreach (DataGridViewColumn column in dataGridView.Columns)
                {
                    column.SortMode = DataGridViewColumnSortMode.NotSortable;
                }

                for (int r = 0; r < rowNumber; r++)
                {
                    dataGridView.Rows[r].Height = (pH - 5) / rowNumber;
                }

                for (int c = 0; c < columnNumber; c++)
                {
                    dataGridView.Columns[c].Width = (pW - 5) / columnNumber;
                }

                dataGridView.AllowUserToResizeColumns = false;
                dataGridView.AllowUserToResizeRows = false;

            }

            for (int r = 0; r < rowNumber; r++)
            {
                dataGridView.Rows[r].HeaderCell.Value = (r + 1).ToString();
                for (int c = 0; c < columnNumber; c++)
                {
                    dataGridView.Columns[c].HeaderCell.Value = (c + 1).ToString();
                    //valtmp = (r + 1).ToString() + "-" + (c + 1).ToString();
                    valtmp = (c * rowNumber + r + 1).ToString();
                    dataGridView.Rows[r].Cells[c].Value = valtmp;
                    dataGridView.Rows[r].Cells[c].Selected = false;
                }
            }

            if (selectSC > 0 && selectEC > 0 && selectSR > 0 && selectER > 0)
            {
                int startNum = (selectSC - 1) * rowNumber + selectSR;
                int endNum = (selectEC - 1) * rowNumber + selectER;
                for (int i = startNum; i <= endNum; i++)
                {
                    int tmpc = (i - 1) / rowNumber;
                    int tmpr = i - tmpc * rowNumber - 1;
                    dataGridView.Rows[tmpr].Cells[tmpc].Selected = true;
                }
            }

        }

    }



}
